Loading

/etc/init.d/znc

  1. #! /bin/sh
  2. ### BEGIN INIT INFO
  3. # Provides:          znc
  4. # Default-Start:     2 3 4 5
  5. # Default-Stop:      0 1 6
  6. # Required-Start:    $local_fs $remote_fs $network $syslog $named
  7. # Required-Stop:     $local_fs $remote_fs $network $syslog $named
  8. # Short-Description: znc initscript
  9. # Description:       This is the init-Script for znc.
  10. ### END INIT INFO
  11.  
  12. # Author: Henner M. Kruse
  13. #
  14. # Please remove the "Author" lines above and replace them
  15. # with your own name if you copy and modify this script.
  16.  
  17. # Do NOT "set -e"
  18. ## su ircd -c "/usr/local/bin/znc"
  19. # PATH should only include /usr/* if it runs after the mountnfs.sh script
  20. PATH=/sbin:/usr/sbin:/bin:/usr/bin
  21. DESC="znc, an advanced modular IRC bouncer"
  22. NAME=znc
  23. DAEMON=/usr/local/bin/$NAME
  24. DAEMON_ARGS="-d /home/ircd/znc/znc"
  25. PIDFILE=/var/run/$NAME.pid
  26. SCRIPTNAME=/etc/init.d/$NAME
  27. USER=ircd
  28. GROUP=znc
  29.  
  30. # Exit if the package is not installed
  31. [ -x "$DAEMON" ] || exit 0
  32.  
  33. # Read configuration variable file if it is present
  34. [ -r /etc/default/$NAME ] && . /etc/default/$NAME
  35.  
  36. # Load the VERBOSE setting and other rcS variables
  37. . /lib/init/vars.sh
  38.  
  39. # Define LSB log_* functions.
  40. # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
  41. . /lib/lsb/init-functions
  42.  
  43. #
  44. # Function that starts the daemon/service
  45. #
  46. do_start()
  47. {
  48.         # Return
  49.         #   0 if daemon has been started
  50.         #   1 if daemon was already running
  51.         #   2 if daemon could not be started
  52.         start-stop-daemon --start --quiet --chuid $USER --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
  53.                 || return 1
  54.         start-stop-daemon --start --quiet --chuid $USER --pidfile $PIDFILE --exec $DAEMON  \
  55.                 || return 2
  56. #       --      $DAEMON_ARGS \
  57.         # Add code here, if necessary, that waits for the process to be ready
  58.         # to handle requests from services started subsequently which depend
  59.         # on this one.  As a last resort, sleep for some time.
  60. }
  61.  
  62. #
  63. # Function that stops the daemon/service
  64. #
  65. do_stop()
  66. {
  67.         # Return
  68.         #   0 if daemon has been stopped
  69.         #   1 if daemon was already stopped
  70.         #   2 if daemon could not be stopped
  71.         #   other if a failure occurred
  72.         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --chuid $USER:$GROUP --pidfile $PIDFILE --name $NAME
  73.         RETVAL="$?"
  74.         [ "$RETVAL" = 2 ] && return 2
  75.         # Wait for children to finish too if this is a daemon that forks
  76.         # and if the daemon is only ever run from this initscript.
  77.         # If the above conditions are not satisfied then add some other code
  78.         # that waits for the process to drop all resources that could be
  79.         # needed by services started subsequently.  A last resort is to
  80.         # sleep for some time.
  81.         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --chuid $USER:$GROUP --exec $DAEMON
  82.         [ "$?" = 2 ] && return 2
  83.         # Many daemons don't delete their pidfiles when they exit.
  84.         rm -f $PIDFILE
  85.         return "$RETVAL"
  86. }
  87.  
  88. #
  89. # Function that sends a SIGHUP to the daemon/service
  90. #
  91. do_reload() {
  92.         #
  93.         # If the daemon can reload its configuration without
  94.         # restarting (for example, when it is sent a SIGHUP),
  95.         # then implement that here.
  96.         #
  97.         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --chuid $USER:$GROUP --name $NAME
  98.         return 0
  99. }
  100.  
  101. case "$1" in
  102.   start)
  103.         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
  104.         do_start
  105.         case "$?" in
  106.                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  107.                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  108.         esac
  109.         ;;
  110.   stop)
  111.         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
  112.         do_stop
  113.         case "$?" in
  114.                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
  115.                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
  116.         esac
  117.         ;;
  118.   #reload|force-reload)
  119.         #
  120.         # If do_reload() is not implemented then leave this commented out
  121.         # and leave 'force-reload' as an alias for 'restart'.
  122.         #
  123.         #log_daemon_msg "Reloading $DESC" "$NAME"
  124.         #do_reload
  125.         #log_end_msg $?
  126.         #;;
  127.   restart|force-reload)
  128.         #
  129.         # If the "reload" option is implemented then remove the
  130.         # 'force-reload' alias
  131.         #
  132.         log_daemon_msg "Restarting $DESC" "$NAME"
  133.         do_stop
  134.         case "$?" in
  135.           0|1)
  136.                 do_start
  137.                 case "$?" in
  138.                         0) log_end_msg 0 ;;
  139.                         1) log_end_msg 1 ;; # Old process is still running
  140.                         *) log_end_msg 1 ;; # Failed to start
  141.                 esac
  142.                 ;;
  143.           *)
  144.                 # Failed to stop
  145.                 log_end_msg 1
  146.                 ;;
  147.         esac
  148.         ;;
  149.   *)
  150.         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
  151.         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
  152.         exit 3
  153.         ;;
  154. esac
  155.  
  156. :

Comments